
#include "types.h"

#include "address.h"


#ifdef DEBUG_SIMULATION

uint32_t pltops[] = { 0 };

uint32_t loaded_annotations_second[] = { 0 };

uint32_t debug_memory[] = { 0 };

uint32_t kernel_to_monitor_memory[] = { 0x00000000, 0x00000002, 0x23, 0x42, 0x432, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 };

uint32_t monitor_to_kernel_memory[] = { 0x0, 0x0, 0x0, 0x0, 0x0 };

uint32_t instrumentation_memory[] = { 0x12121212, 0x23232323 };

uint32_t config_security_policy_memory[] = {0x2, 0x0, 0x6, 0x7, 0x2, 0x4, 0x1, 0x5, 0x9, 0x8, 0x0, 0x2, 0x5, 0x3, 0x2, 0x0, 0x12121212, 0x32323232, 0x43434343, 0x54545454, 0x65656565};

uint32_t loaded_bbt_annotations[] = {0x9, 0x102e4, 0x4c, 0x10314, 0x54, 0x10338, 0x60, 0x10344, 0x68, 0x10350, 0x74, 0x103a4, 0x198, 0x103bc, 0x1b0, 0x103dc, 0x1cc, 0x103fc, 0x1e4, 0x1, 0x81a00000, 0x2, 0x2200000, 0xbc031000, 0x1, 0x81a00000, 0x2, 0x81a00000, 0x81a00000, 0x48, 0x3c00000, 0x80200008, 0x903c1000, 0x903c1004, 0x903c1008, 0x903c100c, 0x903c1010, 0x903c1014, 0x903c1018, 0x903c101c, 0x903c1020, 0x903c1024, 0x903c1028, 0x903c102c, 0x903c1030, 0x903c1034, 0x903c1038, 0x903c103c, 0x903c1040, 0x903c1044, 0x903c1048, 0x903c104c, 0x903c1052, 0x903c1056, 0x903c105a, 0x903c105e, 0x903c1062, 0x903c1066, 0x903c106a, 0x903c106e, 0x903c1072, 0x903c1076, 0x903c107a, 0x903c107e, 0x903c1082, 0x903c1086, 0x903c108a, 0x903c108e, 0x903c1092, 0x903c1096, 0x903c109a, 0x903c109e, 0x903c10a2, 0x903c10a6, 0x903c10aa, 0x903c10ae, 0x903c10b2, 0x903c10b6, 0x903c10ba, 0x903c10be, 0x903c10c2, 0x903c10c6, 0x903c10ca, 0x903c10ce, 0x80e0ffff, 0x8100aaaa, 0x8c068380, 0x8c468380, 0x8c868380, 0x8cc68380, 0x8d068380, 0x8d468380, 0x8d868380, 0x8dc68380, 0x8e068380, 0x8e468380, 0x8e868380, 0x8ec68380, 0x8f068380, 0x8f468380, 0x8f868380, 0x8fc68380, 0x5, 0x81a00000, 0x81a00000, 0x81a00000, 0x81a00000, 0x81a00000, 0x6, 0x81a00000, 0x81a00000, 0x81a00000, 0x81a00000, 0x81a00000, 0x81a00000, 0x5, 0x81a00000, 0x81a00000, 0x81a00000, 0x81a00000, 0x81a00000, 0x4, 0x81a00000, 0x81a00000, 0x81a00000, 0x81a00000 };

uint32_t loaded_ptm_traces[] = { 0x15c44, 0x1581c, 0x111a0, 0x10c80, 0x157ec, 0x15704, 0x15c24, 0x15c40, 0xffff0008, 0x15c44, 0xffff0008, 0x1581c, 0x111a0, 0x10c90, 0x10dd8, 0x10de8, 0x10edc, 0x10f44, 0xffff0018, 0x10f44, 0x10ee4, 0x10114, 0x10ef0, 0xffff0010, 0x10f08, 0x10288, 0x102b0, 0x1020c, 0x10f10, 0x10f48, 0x10350, 0x10364, 0xffff0010, 0x10368, 0x15448, 0x154e4, 0xffff0004, 0x154e4, 0x1551c, 0x1551c, 0x1551c, 0x103a4, 0x14c50, 0x14c8c, 0x103bc, 0x102e4, 0x10314, 0x10344, 0x103dc, 0x11a14, 0x11af4, 0x11c70, 0x14778, 0x11d28, 0x11d44, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d80, 0x11dc8, 0x14778, 0x11d28, 0x11d44, 0x11d80, 0x11dc8, 0x11de0, 0x11e20, 0x11e6c, 0x11ec8, 0x11f80, 0x11f94, 0x12004, 0x12100, 0x1214c, 0x12180, 0x148c8, 0x14944, 0x11b48, 0x11b68, 0x11c70, 0x14778, 0x11d28, 0x11d44, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d40, 0x11d80, 0x117a4, 0x117ec, 0x11808, 0x11808, 0x11808, 0x11808, 0x11808, 0x11808, 0x11808, 0x11808, 0x11808, 0x11808, 0x1187c, 0x15068, 0x150a4, 0x15108, 0x1110467888, 0x11dc4, 0x14778, 0x11d28, 0x11d44, 0x11d80, 0x117a4, 0x117ec, 0x1187c, 0x15068, 0x1533c, 0x11888, 0x11dc4, 0x11de0, 0x11e20, 0x11e6c, 0x11ec8, 0x11f80, 0x11f94, 0x12004, 0x12100, 0x1214c, 0x12180, 0x14950, 0x1495c, 0x149e8, 0x14a70, 0x12194, 0x127a8, 0x12838, 0x12ec8, 0x12f00, 0x12f30, 0x1304c, 0x117a4, 0x117ec, 0x1187c, 0x15068, 0x1533c, 0x11888, 0x13068, 0x13138, 0x15448, 0x15538, 0x13164, 0x131d0, 0x117a4, 0x117ec, 0x11808, 0x1187c, 0x15068, 0x1533c, 0x11888, 0x131ec, 0x117a4, 0x117ec, 0x1187c, 0x15068, 0x1533c, 0x11888, 0x13210, 0x11dd0, 0x14778, 0x11d28, 0x11d44, 0x11d40, 0x11d7c, 0x117a4, 0x117ec, 0x16970, 0x169b8, 0xffff0008, 0x169bc, 0x111a0, 0x169c0, 0x16a28, 0x1183c, 0x1187c, 0x15068, 0x1533c, 0x11888, 0x11dc4, 0xffff0018, 0x11dc4, 0x14778, 0x14944, 0x14948, 0xffff0004, 0x14948, 0x11bac, 0x11c3c, 0x11c60, 0x11a4c, 0x103fc, 0x19c, 0x10f58, 0x10120, 0x1103c, 0x10130, 0x10f64, 0x10244, 0xffff0018, 0x10244, 0x101dc, 0x10260, 0x1027c, 0x10f8c, 0x1bfa0, 0x10134, 0x1b0e8, 0x1b2ec, 0x1b318, 0x1b378, 0x1b300, 0x1b0f8, 0x1b11c, 0xffff0018, 0x1b11c, 0x1b140, 0x1b164, 0x1b108, 0x1b11c, 0x1b140, 0x1b164, 0x1b1e4, 0x1b20c, 0x1b230, 0x1b258, 0x10138, 0x1016c, 0xffff0018, 0x1016c, 0x15c00, 0x15c10 };


void *memcpy(void *dst, const void *src, unsigned long bytes)
{      uint32_t *Dst32 = (uint32_t*)dst, *Src32 = (uint32_t*)src;
      bytes >>= 2;
      while((int)bytes-- > 0)
         *Dst32++ = *Src32++;

   return dst;
}

uint32_t* addr_to_read_kernel_to_monitor = (uint32_t *)KERNEL_TO_MONITOR;

uint32_t* SimulationGetNextKernelToMonitorAddress(){
   ++addr_to_read_kernel_to_monitor;
   MemoryWrite(KERNEL_TO_MONITOR, *addr_to_read_kernel_to_monitor);
   return addr_to_read_kernel_to_monitor;
}


uint32_t* trace_address = (uint32_t *)PTM_TRACES_ADDRESS;

uint32_t* nextPTMtraceAddress(void){
  return trace_address++;
}

uint32_t* addr_to_write_pltops = (uint32_t *)PLTOPS;

uint32_t* getPLtoPSAddress(){

  return ++addr_to_write_pltops;

}


#else


uint32_t* nextPTMtraceAddress(void){
  return (uint32_t *)PTM_TRACES_ADDRESS;
}

uint32_t* addr_to_write_debug = (uint32_t *)DEBUG_BRAM;

uint32_t* getDebugAddress(){

  return ++addr_to_write_debug;

}

uint32_t* addr_to_write_pltops = (uint32_t *)PLTOPS;

uint32_t* getPLtoPSAddress(){

  return ++addr_to_write_pltops;

}

#endif

